# Tweak to have debuginfo - part 1/2
%if 0%{?fedora} >= 7
%define __debug_install_post %{_builddir}/%{?buildsubdir}/find-debuginfo.sh %{_builddir}/%{?buildsubdir}\
%{nil}
%endif

Summary:	NVIDIA CUDA Toolkit libraries
Name:		cudatoolkit
Version:	2.1
Release:	2%{?dist}
License:	Redistributable, no modification permitted
Group:		Development/Languages
URL:		http://www.nvidia.com/cuda
Source0:	%{name}_%{version}_linux32_fedora9.run
Source1:	%{name}_%{version}_linux64_fedora9.run
Source2:	%{name}-init-d
BuildRoot:	%(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)

Requires:	chkconfig
Requires:   %{name}-libs = %{version}-%{release}
Provides:	cuda

%description
NVIDIA(R)CUDA(TM) is a general purpose parallel computing architecture
that leverages the parallel compute engine in NVIDIA graphics
processing units (GPUs) to solve many complex computational problems
in a fraction of the time required on a CPU. It includes the CUDA
Instruction Set Architecture (ISA) and the parallel compute engine in
the GPU. To program to the CUDATM architecture, developers can, today,
use C, one of the most widely used high-level programming languages,
which can then be run at great performance on a CUDATM enabled
processor. Other languages will be supported in the future, including
FORTRAN and C++.

This package contains the libraries and attendant files needed to run
programs that make use of CUDA.

%package libs
Summary:	Libraries for %{name}
Group:		Development/Libraries

%description libs
This package contains libraries needed for running CUDA based applications.

%prep
%setup -q -T -c %{name}-%{version}

# Tweak to have debuginfo - part 2/2
%if 0%{?fedora} >= 7
cp -p %{_prefix}/lib/rpm/find-debuginfo.sh .
sed -i -e 's|strict=true|strict=false|' find-debuginfo.sh
%endif

%build
# Nothing to build
echo "Nothing to build"

%install
rm -rf $RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT%{_prefix}

%ifarch %{ix86}
bash %{SOURCE0} --tar xf -C $RPM_BUILD_ROOT%{_prefix}
%else
bash %{SOURCE1} --tar xf -C $RPM_BUILD_ROOT%{_prefix}
%endif

# move to proper locations
mv $RPM_BUILD_ROOT%{_prefix}/lib $RPM_BUILD_ROOT%{_libdir} || :
sed -i 's/lib/%{_lib}/g' $RPM_BUILD_ROOT%{_bindir}/nvcc.profile

mv $RPM_BUILD_ROOT%{_prefix}/open64/bin/* $RPM_BUILD_ROOT%{_bindir}
mv $RPM_BUILD_ROOT%{_prefix}/open64/lib/* $RPM_BUILD_ROOT%{_bindir}

# we use rmdir instead of rm -rf to make sure we don't forget anything to package in new versions.
rmdir $RPM_BUILD_ROOT%{_prefix}/open64/{lib,bin}
rmdir $RPM_BUILD_ROOT%{_prefix}/open64

mv $RPM_BUILD_ROOT%{_prefix}/doc ./
install -p -d -m 755 $RPM_BUILD_ROOT%{_datadir}
mv $RPM_BUILD_ROOT%{_prefix}/man $RPM_BUILD_ROOT%{_mandir} || :

# remove unnecessary files
rm -rf $RPM_BUILD_ROOT%{_prefix}/src
rm -f $RPM_BUILD_ROOT%{_prefix}/install-linux.pl

# init script
install -p -D -m 755 %{SOURCE2} $RPM_BUILD_ROOT%{_initrddir}/%{name}

# fix permissions to enable stripping
chmod -R u+w,a+r $RPM_BUILD_ROOT

# fix utf8
iconv -f ISO88591 -t UTF8 < doc/NVIDIA_CUDA_Programming_Guide_Revision_History.txt > doc/NVIDIA_CUDA_Programming_Guide_Revision_History.txt.utf8
touch -r doc/NVIDIA_CUDA_Programming_Guide_Revision_History.txt doc/NVIDIA_CUDA_Programming_Guide_Revision_History.txt.utf8
mv -f doc/NVIDIA_CUDA_Programming_Guide_Revision_History.txt.utf8 doc/NVIDIA_CUDA_Programming_Guide_Revision_History.txt

# add shebang (although this will be mostly just sourced)
echo "#!/bin/bash" > $RPM_BUILD_ROOT%{_bindir}/nvcc.profile.new
cat $RPM_BUILD_ROOT%{_bindir}/nvcc.profile >> $RPM_BUILD_ROOT%{_bindir}/nvcc.profile.new
touch -r $RPM_BUILD_ROOT%{_bindir}/nvcc.profile $RPM_BUILD_ROOT%{_bindir}/nvcc.profile.new
mv $RPM_BUILD_ROOT%{_bindir}/nvcc.profile.new $RPM_BUILD_ROOT%{_bindir}/nvcc.profile

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/ldconfig
/sbin/chkconfig --add %{name} || :

%preun
if [ $1 -eq 0 ]; then #if uninstalling, not only updating
	/sbin/service %{name} stop || :
	/sbin/chkconfig --del %{name} || :
fi

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root,-)
%attr(755,root,root) %{_bindir}/*
%doc doc/*
%{_includedir}/*
%{_mandir}/man1/*
%{_mandir}/man3/*

%files libs
%defattr(-,root,root,-)
%{_initrddir}/%{name}
%{_libdir}/*

%changelog
* Sun Apr 13 2009 Milos Jakubicek <xjakub@fi.muni.cz> - 2.1-2
- Added %%{dist} tag
- Removed -devel subpackage
- Enable multilib by splitting the libraries into a -libs subpackage
- Added R: -libs subpackage
- Fixed installation on 32bit archs, safe usage of mv/rm/rmmod commands (|| :)
- Fixed init script in order to enable uninstallation even if the module is not loaded
- Changed RPM group
- Proper macro usage
- Preserving all timestamps
- Enable debuginfo by making it not so strict (not requiring build id)

* Sat Mar 21 2009 Milos Jakubicek <xjakub@fi.muni.cz> - 2.1-1
- Initial package based on Mandriva package made by Lev Givon.

